ulocbuilder.h File Reference

C API: Builder API for Locale. More...

`#include "unicode/localpointer.h"`
`#include "unicode/ulocale.h"`
`#include "unicode/utypes.h"`

Go to the source code of this file.

## Namespaces

| icu
| File coll.h.

## Typedefs

typedef struct ULocaleBuilder | ULocaleBuilder
| C typedef for struct ULocaleBuilder. More...

## Functions

U_CAPI ULocaleBuilder * | ulocbld_open (void)
| `ULocaleBuilder` is used to build valid `locale` id string or IETF BCP 47 language tag from values configured by the setters. More...
U_CAPI void | ulocbld_close (ULocaleBuilder *builder)
| Close the builder and destroy it's internal states. More...
U_CAPI void | ulocbld_setLocale (ULocaleBuilder *builder, const char *locale, int32_t length)
| Resets the `ULocaleBuilder` to match the provided `locale`. More...
U_CAPI void | ulocbld_adoptULocale (ULocaleBuilder *builder, ULocale *locale)
| Resets the `ULocaleBuilder` to match the provided `ULocale`. More...
U_CAPI void | ulocbld_setLanguageTag (ULocaleBuilder *builder, const char *tag, int32_t length)
| Resets the ULocaleBuilder to match the provided IETF BCP 47 language tag. More...
U_CAPI void | ulocbld_setLanguage (ULocaleBuilder *builder, const char *language, int32_t length)
| Sets the language. More...
U_CAPI void | ulocbld_setScript (ULocaleBuilder *builder, const char *script, int32_t length)
| Sets the script. More...
U_CAPI void | ulocbld_setRegion (ULocaleBuilder *builder, const char *region, int32_t length)
| Sets the region. More...
U_CAPI void | ulocbld_setVariant (ULocaleBuilder *builder, const char *variant, int32_t length)
| Sets the variant. More...
U_CAPI void | ulocbld_setExtension (ULocaleBuilder *builder, char key, const char *value, int32_t length)
| Sets the extension for the given key. More...
U_CAPI void | ulocbld_setUnicodeLocaleKeyword (ULocaleBuilder *builder, const char *key, int32_t keyLength, const char *type, int32_t typeLength)
| Sets the Unicode locale keyword type for the given key. More...
U_CAPI void | ulocbld_addUnicodeLocaleAttribute (ULocaleBuilder *builder, const char *attribute, int32_t length)
| Adds a unicode locale attribute, if not already present, otherwise has no effect. More...
U_CAPI void | ulocbld_removeUnicodeLocaleAttribute (ULocaleBuilder *builder, const char *attribute, int32_t length)
| Removes a unicode locale attribute, if present, otherwise has no effect. More...
U_CAPI void | ulocbld_clear (ULocaleBuilder *builder)
| Resets the builder to its initial, empty state. More...
U_CAPI void | ulocbld_clearExtensions (ULocaleBuilder *builder)
| Resets the extensions to their initial, empty state. More...
U_CAPI int32_t | ulocbld_buildLocaleID (ULocaleBuilder *builder, char *locale, int32_t localeCapacity, UErrorCode *err)
| Build the LocaleID string from the fields set on this builder. More...
U_CAPI ULocale * | ulocbld_buildULocale (ULocaleBuilder *builder, UErrorCode *err)
| Build the ULocale object from the fields set on this builder. More...
U_CAPI int32_t | ulocbld_buildLanguageTag (ULocaleBuilder *builder, char *language, int32_t languageCapacity, UErrorCode *err)
| Build the IETF BCP 47 language tag string from the fields set on this builder. More...
U_CAPI UBool | ulocbld_copyErrorTo (const ULocaleBuilder *builder, UErrorCode *outErrorCode)
| Sets the UErrorCode if an error occurred while recording sets. More...

## Detailed Description

C API: Builder API for Locale.

Definition in file ulocbuilder.h.

## Typedef Documentation

## ULocaleBuilder

typedef struct ULocaleBuilder ULocaleBuilder

C typedef for struct ULocaleBuilder.

Stable:
  ICU 74

Definition at line 1 of file ulocbuilder.h.

## Function Documentation

## ulocbld_addUnicodeLocaleAttribute()

U_CAPI void ulocbld_addUnicodeLocaleAttribute | ( | ULocaleBuilder * | builder,
|  | const char * | attribute,
|  | int32_t | length
| ) |  |

Adds a unicode locale attribute, if not already present, otherwise has no effect.

The attribute must not be empty string and must be well-formed or U_ILLEGAL_ARGUMENT_ERROR will be set to status during the ulocbld_buildLocaleID() and ulocbld_buildLanguageTag() calls.

Parameters

  builder | the builder
  attribute | the attribute, a const char * pointer (need not be terminated when the length is non-negative)
  length | the length of the attribute; if negative, then the attribute need to be null terminated,

Stable:
  ICU 74

## ulocbld_adoptULocale()

U_CAPI void ulocbld_adoptULocale | ( | ULocaleBuilder * | builder,
|  | ULocale * | locale
| ) |  |

Resets the `ULocaleBuilder` to match the provided `ULocale`.

Existing state is discarded.

The locale must be not bogus.

This method clears the internal UErrorCode.

Parameters

  builder | the builder.
  locale | the locale, a ULocale* pointer. The builder adopts the locale after the call and the client must not delete it.

Stable:
  ICU 74

## ulocbld_buildLanguageTag()

U_CAPI int32_t ulocbld_buildLanguageTag | ( | ULocaleBuilder * | builder,
|  | char * | language,
|  | int32_t | languageCapacity,
|  | UErrorCode * | err
| ) |  |

Build the IETF BCP 47 language tag string from the fields set on this builder.

If any set methods or during the ulocbld_buildLanguageTag() call require memory allocation but fail U_MEMORY_ALLOCATION_ERROR will be set to status. If any of the fields set by the setters are not well-formed, the status will be set to U_ILLEGAL_ARGUMENT_ERROR. The state of the builder will not change after the ulocbld_buildLanguageTag() call and the caller is free to keep using the same builder to build more locales.

Parameters

  builder | the builder
  language | the language tag
  languageCapacity | the size of the language buffer to store the language tag
  err | the error code

Returns
  the length of the language tag in buffer

Stable:
  ICU 74

## ulocbld_buildLocaleID()

U_CAPI int32_t ulocbld_buildLocaleID | ( | ULocaleBuilder * | builder,
|  | char * | locale,
|  | int32_t | localeCapacity,
|  | UErrorCode * | err
| ) |  |

Build the LocaleID string from the fields set on this builder.

If any set methods or during the ulocbld_buildLocaleID() call require memory allocation but fail U_MEMORY_ALLOCATION_ERROR will be set to status. If any of the fields set by the setters are not well-formed, the status will be set to U_ILLEGAL_ARGUMENT_ERROR. The state of the builder will not change after the ulocbld_buildLocaleID() call and the caller is free to keep using the same builder to build more locales.

Parameters

  builder | the builder
  locale | the locale id
  localeCapacity | the size of the locale buffer to store the locale id
  err | the error code

Returns
  the length of the locale id in buffer

Stable:
  ICU 74

## ulocbld_buildULocale()

U_CAPI ULocale* ulocbld_buildULocale | ( | ULocaleBuilder * | builder,
|  | UErrorCode * | err
| ) |  |

Build the ULocale object from the fields set on this builder.

If any set methods or during the ulocbld_buildULocale() call require memory allocation but fail U_MEMORY_ALLOCATION_ERROR will be set to status. If any of the fields set by the setters are not well-formed, the status will be set to U_ILLEGAL_ARGUMENT_ERROR. The state of the builder will not change after the ulocbld_buildULocale() call and the caller is free to keep using the same builder to build more locales.

Parameters

  builder | the builder.
  err | the error code.

Returns
  the locale, a ULocale* pointer. The created ULocale must be destroyed by calling ulocale_close.

Stable:
  ICU 74

## ulocbld_clear()

U_CAPI void ulocbld_clear | ( | ULocaleBuilder * | builder | ) |

Resets the builder to its initial, empty state.

This method clears the internal UErrorCode.

Parameters

  builder | the builder

Stable:
  ICU 74

## ulocbld_clearExtensions()

U_CAPI void ulocbld_clearExtensions | ( | ULocaleBuilder * | builder | ) |

Resets the extensions to their initial, empty state.

Language, script, region and variant are unchanged.

Parameters

  builder | the builder

Stable:
  ICU 74

## ulocbld_close()

U_CAPI void ulocbld_close | ( | ULocaleBuilder * | builder | ) |

Close the builder and destroy it's internal states.

Parameters

  builder | the builder

Stable:
  ICU 74

## ulocbld_copyErrorTo()

U_CAPI UBool ulocbld_copyErrorTo | ( | const ULocaleBuilder * | builder,
|  | UErrorCode * | outErrorCode
| ) |  |

Sets the UErrorCode if an error occurred while recording sets.

Preserves older error codes in the outErrorCode.

Parameters

  builder | the builder
  outErrorCode | Set to an error code that occurred while setting subtags. Unchanged if there is no such error or if outErrorCode already contained an error.

Returns
  true if U_FAILURE(*outErrorCode)

Stable:
  ICU 74

## ulocbld_open()

U_CAPI ULocaleBuilder* ulocbld_open | ( | void |  | ) |

`ULocaleBuilder` is used to build valid `locale` id string or IETF BCP 47 language tag from values configured by the setters.

The `ULocaleBuilder` checks if a value configured by a setter satisfies the syntax requirements defined by the `Locale` class. A string of Locale created by a `ULocaleBuilder` is well-formed and can be transformed to a well-formed IETF BCP 47 language tag without losing information.

The following example shows how to create a `locale` string with the `ULocaleBuilder`.

>         UErrorCode err = U_ZERO_ERROR;
>         char buffer[ULOC_FULLNAME_CAPACITY];
>         ULocaleBuilder* builder = ulocbld_open();
>         ulocbld_setLanguage(builder, "sr", -1);
>         ulocbld_setScript(builder, "Latn", -1);
>         ulocbld_setRegion(builder, "RS", -1);
>         int32_t length = ulocbld_buildLocaleID(
>             builder, buffer, ULOC_FULLNAME_CAPACITY, &error);
>         ulocbld_close(builder);

ULocaleBuilders can be reused; `ulocbld_clear()` resets all fields to their default values.

ULocaleBuilder tracks errors in an internal UErrorCode. For all setters, except ulocbld_setLanguageTag and ulocbld_setLocale, ULocaleBuilder will return immediately if the internal UErrorCode is in error state. To reset internal state and error code, call clear method. The ulocbld_setLanguageTag and setLocale method will first clear the internal UErrorCode, then track the error of the validation of the input parameter into the internal UErrorCode.

Stable:
  ICU 74

Constructs an empty ULocaleBuilder. The default value of all fields, extensions, and private use information is the empty string. The created builder should be destroyed by calling ulocbld_close();

Stable:
  ICU 74

## ulocbld_removeUnicodeLocaleAttribute()

U_CAPI void ulocbld_removeUnicodeLocaleAttribute | ( | ULocaleBuilder * | builder,
|  | const char * | attribute,
|  | int32_t | length
| ) |  |

Removes a unicode locale attribute, if present, otherwise has no effect.

The attribute must not be empty string and must be well-formed or U_ILLEGAL_ARGUMENT_ERROR will be set to status during the ulocbld_buildLocaleID() and ulocbld_buildLanguageTag() calls.

Attribute comparison for removal is case-insensitive.

Parameters

  builder | the builder
  attribute | the attribute, a const char * pointer (need not be terminated when the length is non-negative)
  length | the length of the attribute; if negative, then the attribute need to be null terminated,

Stable:
  ICU 74

## ulocbld_setExtension()

U_CAPI void ulocbld_setExtension | ( | ULocaleBuilder * | builder,
|  | char | key,
|  | const char * | value,
|  | int32_t | length
| ) |  |

Sets the extension for the given key.

If the value is the empty string, the extension is removed. Otherwise, the `key` and `value` must be well-formed, or else the ulocbld_buildLocaleID() and ulocbld_buildLanguageTag() methods will later report an U_ILLEGAL_ARGUMENT_ERROR.

Note: The key ('u') is used for the Unicode locale extension. Setting a value for this key replaces any existing Unicode locale key/type pairs with those defined in the extension.

Note: The key ('x') is used for the private use code. To be well-formed, the value for this key needs only to have subtags of one to eight alphanumeric characters, not two to eight as in the general case.

Parameters

  builder | the builder
  key | the extension key
  value | the value, a const char * pointer (need not be terminated when the length is non-negative)
  length | the length of the value; if negative, then the value need to be null terminated,

Stable:
  ICU 74

## ulocbld_setLanguage()

U_CAPI void ulocbld_setLanguage | ( | ULocaleBuilder * | builder,
|  | const char * | language,
|  | int32_t | length
| ) |  |

Sets the language.

If `language` is the empty string, the language in this `ULocaleBuilder` is removed. Otherwise, the `language` must be well-formed, or else the ulocbld_buildLocaleID() and ulocbld_buildLanguageTag() methods will later report an U_ILLEGAL_ARGUMENT_ERROR.

The syntax of language value is defined as unicode_language_subtag.

Parameters

  builder | the builder
  language | the language, a const char * pointer (need not be terminated when the length is non-negative)
  length | the length of the language; if negative, then the language need to be null terminated,

Stable:
  ICU 74

## ulocbld_setLanguageTag()

U_CAPI void ulocbld_setLanguageTag | ( | ULocaleBuilder * | builder,
|  | const char * | tag,
|  | int32_t | length
| ) |  |

Resets the ULocaleBuilder to match the provided IETF BCP 47 language tag.

Discards the existing state. The empty string causes the builder to be reset, like ulocbld_clear. Legacy language tags (marked as “Type: grandfathered” in BCP 47) are converted to their canonical form before being processed. Otherwise, the `language tag` must be well-formed, or else the ulocbld_buildLocaleID() and ulocbld_buildLanguageTag() methods will later report an U_ILLEGAL_ARGUMENT_ERROR.

This method clears the internal UErrorCode.

Parameters

  builder | the builder
  tag | the language tag, defined as IETF BCP 47 language tag, a const char * pointer (need not be terminated when the length is non-negative)
  length | the length of the tag; if negative, then the tag need to be null terminated,

Stable:
  ICU 74

## ulocbld_setLocale()

U_CAPI void ulocbld_setLocale | ( | ULocaleBuilder * | builder,
|  | const char * | locale,
|  | int32_t | length
| ) |  |

Resets the `ULocaleBuilder` to match the provided `locale`.

Existing state is discarded.

All fields of the locale must be well-formed.

This method clears the internal UErrorCode.

Parameters

  builder | the builder
  locale | the locale, a const char * pointer (need not be terminated when the length is non-negative)
  length | the length of the locale; if negative, then the locale need to be null terminated,

Stable:
  ICU 74

## ulocbld_setRegion()

U_CAPI void ulocbld_setRegion | ( | ULocaleBuilder * | builder,
|  | const char * | region,
|  | int32_t | length
| ) |  |

Sets the region.

If region is the empty string, the region in this `ULocaleBuilder` is removed. Otherwise, the `region` must be well-formed, or else the ulocbld_buildLocaleID() and ulocbld_buildLanguageTag() methods will later report an U_ILLEGAL_ARGUMENT_ERROR.

The region value is defined by unicode_region_subtag as a two-letter ISO 3166 code or a three-digit UN M.49 area code.

The region value in the `Locale` created by the `ULocaleBuilder` is always normalized to upper case.

Parameters

  builder | the builder
  region | the region, a const char * pointer (need not be terminated when the length is non-negative)
  length | the length of the region; if negative, then the region need to be null terminated,

Stable:
  ICU 74

## ulocbld_setScript()

U_CAPI void ulocbld_setScript | ( | ULocaleBuilder * | builder,
|  | const char * | script,
|  | int32_t | length
| ) |  |

Sets the script.

If `script` is the empty string, the script in this `ULocaleBuilder` is removed. Otherwise, the `script` must be well-formed, or else the ulocbld_buildLocaleID() and ulocbld_buildLanguageTag() methods will later report an U_ILLEGAL_ARGUMENT_ERROR.

The script value is a four-letter script code as unicode_script_subtag defined by ISO 15924

Parameters

  builder | the builder
  script | the script, a const char * pointer (need not be terminated when the length is non-negative)
  length | the length of the script; if negative, then the script need to be null terminated,

Stable:
  ICU 74

## ulocbld_setUnicodeLocaleKeyword()

U_CAPI void ulocbld_setUnicodeLocaleKeyword | ( | ULocaleBuilder * | builder,
|  | const char * | key,
|  | int32_t | keyLength,
|  | const char * | type,
|  | int32_t | typeLength
| ) |  |

Sets the Unicode locale keyword type for the given key.

If the type StringPiece is constructed with a nullptr, the keyword is removed. If the type is the empty string, the keyword is set without type subtags. Otherwise, the key and type must be well-formed, or else the ulocbld_buildLocaleID() and ulocbld_buildLanguageTag() methods will later report an U_ILLEGAL_ARGUMENT_ERROR.

Keys and types are converted to lower case.

Note:Setting the 'u' extension via ulocbld_setExtension replaces all Unicode locale keywords with those defined in the extension.

Parameters

  builder | the builder
  key | the Unicode locale key, a const char * pointer (need not be terminated when the length is non-negative)
  keyLength | the length of the key; if negative, then the key need to be null terminated,
  type | the Unicode locale type, a const char * pointer (need not be terminated when the length is non-negative)
  typeLength | the length of the type; if negative, then the type need to be null terminated,

Returns
  This builder.

Stable:
  ICU 74

## ulocbld_setVariant()

U_CAPI void ulocbld_setVariant | ( | ULocaleBuilder * | builder,
|  | const char * | variant,
|  | int32_t | length
| ) |  |

Sets the variant.

If variant is the empty string, the variant in this `ULocaleBuilder` is removed. Otherwise, the `variant` must be well-formed, or else the ulocbld_buildLocaleID() and ulocbld_buildLanguageTag() methods will later report an U_ILLEGAL_ARGUMENT_ERROR.

Note: This method checks if `variant` satisfies the unicode_variant_subtag syntax requirements, and normalizes the value to lowercase letters. However, the `Locale` class does not impose any syntactic restriction on variant. To set an ill-formed variant, use a Locale constructor. If there are multiple unicode_variant_subtag, the caller must concatenate them with '-' as separator (ex: "foobar-fibar").

Parameters

  builder | the builder
  variant | the variant, a const char * pointer (need not be terminated when the length is non-negative)
  length | the length of the variant; if negative, then the variant need to be null terminated,

Stable:
  ICU 74